schedule function rebal_piglins:1t 1t

#CHECK DIFFICULTY
execute store result score rebal_piglins.sc rebal_piglins.di run difficulty

#PIGLINS PICK UP ITEMS AFTER FIGHT IF ITEM NEARBY
execute as @e[type=piglin,tag=!rebal_piglins.piglin_brute,nbt=!{CanPickUpLoot:1b},predicate=!rebal_piglins:angry,tag=rebal_piglins.bal] at @s run execute if entity @e[type=item,distance=..1.5] run data merge entity @s {CanPickUpLoot:1b}

#PIGLINS WILL NOT BE DISTRACTED IN MIDDLE OF A FIGHT
execute as @e[type=piglin,tag=!rebal_piglins.piglin_brute,nbt=!{CanPickUpLoot:0b},predicate=rebal_piglins:angry,tag=rebal_piglins.bal] at @s run data merge entity @s {CanPickUpLoot:0b}

#MAXIMUM PERSISTENT PIGLINS IN BASTION
execute as @e[type=#rebal_piglins:piglins,tag=!rebal_piglins.tagged,tag=!rebal_piglins.piglin_brute,tag=!smithed.entity,nbt=!{PersistenceRequired:1b},predicate=rebal_piglins:location/bastion] at @s run function rebal_piglins:persistent/piglin
tag @e[type=piglin,tag=!rebal_piglins.tagged] add rebal_piglins.tagged

#REAL BRUTE ATTACK PIG ZOMBIES IF ENABLED HOSTILITY OF PIG ZOMBIES
execute unless score rebal_piglins.sc rebal_piglins.za matches 1 run execute as @e[type=piglin_brute,tag=rebal_piglins.bal,predicate=rebal_piglins:angryat/player] at @s run data modify entity @s Brain.memories."minecraft:angry_at".value set from entity @e[type=#rebal_piglins:pig_zombie,tag=!smithed.entity,nbt=!{Invulnerable:1b},limit=1,sort=nearest,distance=..16] UUID

#PIGLIN BRUTE ATTACK PIG ZOMBIES IF ENABLED HOSTILITY OF PIG ZOMBIES
execute unless score rebal_piglins.sc rebal_piglins.za matches 1 run execute as @e[type=#rebal_piglins:piglins,tag=rebal_piglins.bal,tag=rebal_piglins.piglin_brute,predicate=!rebal_piglins:angry] at @s run data modify entity @s Brain.memories."minecraft:angry_at".value set from entity @e[type=zombified_piglin,predicate=rebal_piglins:angryat/piglin,tag=!smithed.entity,nbt=!{Invulnerable:1b},limit=1,sort=nearest,distance=..12] UUID
execute as @e[type=#rebal_piglins:piglins,tag=rebal_piglins.bal,tag=rebal_piglins.piglin_brute,predicate=!rebal_piglins:angry] at @s run data modify entity @s Brain.memories."minecraft:angry_at".value set from entity @e[type=zoglin,tag=!smithed.entity,nbt=!{Invulnerable:1b},limit=1,sort=nearest,distance=..8] UUID

#STATS CHANGER
execute as @e[type=piglin_brute,tag=!rebal_piglins.bal,tag=!smithed.entity] at @s run function rebal_piglins:stats/brute
execute as @e[type=piglin,tag=!rebal_piglins.bal,tag=!smithed.entity] at @s run function rebal_piglins:stats/piglin
tag @e[type=#rebal_piglins:piglins,tag=!rebal_piglins.bal,tag=!smithed.entity] add rebal_piglins.bal

#ZOMBIFIED PIGLIN WARNING
execute unless score rebal_piglins.sc rebal_piglins.zp matches 1 run execute as @a[gamemode=!creative,gamemode=!spectator,advancements={rebal_piglins:zombified_piglin/warning=false}] at @s run execute if entity @e[type=zombified_piglin,tag=!smithed.entity,distance=..16] run advancement grant @s only rebal_piglins:zombified_piglin/warning

#ZOMBIFIED PIGLIN SPOTTED
execute unless score rebal_piglins.sc rebal_piglins.zp matches 1 run execute as @e[type=zombified_piglin,tag=!smithed.entity] at @s run execute if entity @a[gamemode=!creative,gamemode=!spectator,distance=..3,predicate=!rebal_piglins:has/invisibility] run function rebal_piglins:anger/zombified_piglin

#ZOMBIFIED PIGLIN SPOTTED INVISIBLE PLAYER
execute unless score rebal_piglins.sc rebal_piglins.zp matches 1 run execute as @e[type=zombified_piglin,tag=!smithed.entity] at @s run execute at @a[gamemode=!creative,gamemode=!spectator,distance=..1.5] run function rebal_piglins:anger/zombified_piglin

#RESTRICT PIG ZOMBIES
execute unless score rebal_piglins.sc rebal_piglins.rp matches 1 run execute as @e[type=#rebal_piglins:pig_zombie,tag=!rebal_piglins.tagged,tag=!smithed.entity] at @s run execute unless entity @a[gamemode=!spectator,distance=..8] run function rebal_piglins:restrict/pig_zombies

#TAG WARPED FUNGUS ON A STICK HOLDING PIG ZOMBIE
execute as @e[type=zombified_piglin,tag=!rebal_piglins.tagged,tag=!smithed.entity,nbt={HandItems:[{id:"minecraft:warped_fungus_on_a_stick",count:1},{}]}] at @s run tag @s add rebal_piglins.tagged

#ZOMBIFIED PIGLIN DEATHLOOTTABLE
execute unless score rebal_piglins.sc rebal_piglins.lt matches 1 run execute as @e[type=zombified_piglin,tag=!rebal_piglins.tagged,tag=!smithed.entity] at @s run data modify entity @s DeathLootTable set value "rebal_piglins:entities/zombified_piglin"

#BABIFY PIG ZOMBIES WITH 10% CHANCE
execute as @e[type=#rebal_piglins:pig_zombie,tag=!rebal_piglins.tagged,tag=!smithed.entity,predicate=rebal_piglins:chance_10,nbt=!{IsBaby:1b},predicate=!rebal_piglins:has/nausea,nbt=!{HandItems:[{id:"minecraft:warped_fungus_on_a_stick",count:1},{}]}] at @s run execute if entity @s[predicate=!rebal_piglins:has/nausea] run data merge entity @s {IsBaby:1b}

#PIG ZOMBIES NERF IF HOSTILE TO PLAYERS
execute unless score rebal_piglins.sc rebal_piglins.zp matches 1 run execute as @e[type=zombified_piglin,tag=!rebal_piglins.tagged,tag=!smithed.entity] at @s run attribute @s minecraft:attack_damage base set 3

#PIG ZOMBIES WEAPON VARY
execute unless score rebal_piglins.sc rebal_piglins.zv matches 1 run execute as @e[type=zombified_piglin,predicate=!rebal_piglins:has/nausea,tag=!rebal_piglins.tagged,tag=!smithed.entity] at @s run function rebal_piglins:zombified_piglin/weapon_vary

#TAG PIG ZOMBIES
tag @e[type=#rebal_piglins:pig_zombie,tag=!rebal_piglins.tagged,tag=!smithed.entity] add rebal_piglins.tagged

#RESTRICT HOGLINS
execute unless score rebal_piglins.sc rebal_piglins.hr matches 1 run execute as @e[type=hoglin,tag=!rebal_piglins.tagged,tag=!smithed.entity] at @s run execute unless entity @a[gamemode=!spectator,distance=..8] run function rebal_piglins:restrict/hoglin

#TAG HOGLINS
tag @e[type=hoglin,tag=!rebal_piglins.tagged,tag=!smithed.entity] add rebal_piglins.tagged

#CRAZY HUNTING MODE FOR PIGLINS
execute as @e[type=piglin,tag=rebal_piglins.bal,tag=!rebal_piglins.piglin_brute,predicate=!rebal_piglins:angry,nbt=!{CannotHunt:1b},nbt=!{IsBaby:1b}] at @s run execute unless entity @e[type=hoglin,tag=!smithed.entity,distance=..8,nbt={Age:0}] run execute if data entity @s Brain.memories."minecraft:hunted_recently" run data remove entity @s Brain.memories."minecraft:hunted_recently"
execute as @e[type=piglin,tag=rebal_piglins.bal,tag=!rebal_piglins.piglin_brute,predicate=!rebal_piglins:angry,nbt=!{CannotHunt:1b},nbt=!{IsBaby:1b}] at @s run execute if entity @e[type=hoglin,tag=!smithed.entity,distance=8..12,nbt={Age:0}] run execute unless data entity @s Brain.memories."minecraft:hunted_recently" run data modify entity @s Brain.memories."minecraft:angry_at".value set from entity @e[type=hoglin,tag=!smithed.entity,limit=1,sort=nearest,nbt={Age:0}] UUID

#ZOMBIFIED PIGLINS ATTACK PIGLINS
execute unless score rebal_piglins.sc rebal_piglins.za matches 1 run execute as @e[type=zombified_piglin,tag=!smithed.entity] at @s run execute if entity @e[type=#rebal_piglins:piglins,tag=rebal_piglins.bal,distance=..8,nbt=!{Invulnerable:1b}] unless entity @a[gamemode=!creative,gamemode=!spectator,distance=..8] run data modify entity @s AngryAt set from entity @e[type=#rebal_piglins:piglins,tag=rebal_piglins.bal,sort=nearest,limit=1,nbt={Invulnerable:0b}] UUID

#ZOMBIFIED PIGLINS ZOMBIFY PIGLINS
execute as @e[type=#rebal_piglins:piglins,tag=rebal_piglins.bal,tag=rebal_piglins.low,nbt={HurtTime:9s},nbt=!{IsImmuneToZombification:1b}] at @s run execute if entity @e[type=zombified_piglin,tag=!smithed.entity,distance=..2,predicate=rebal_piglins:angryat/piglin] run function rebal_piglins:zombify/1

#LOW HEALTH TAG FOR PIGLINS
execute unless score rebal_piglins.sc rebal_piglins.z matches 1 run execute as @e[type=#rebal_piglins:piglins,tag=rebal_piglins.bal,tag=!rebal_piglins.low,tag=!smithed.entity] at @s run function rebal_piglins:stats/low

#Z.PIGLINS RECEIVE WEAKNESS IF TARGETED LOW HEALTH TAG
execute as @e[type=zombified_piglin,tag=!smithed.entity,predicate=rebal_piglins:angryat/low/piglin] at @s run effect give @s weakness 1 2 true
execute as @e[type=zombified_piglin,tag=!smithed.entity,predicate=rebal_piglins:angryat/low/brute] at @s run effect give @s strength 1 0 true

#PIGLIN INVENTORY FIX
execute if score rebal_piglins.sc rebal_piglins.in matches 1 run execute as @e[type=piglin,tag=rebal_piglins.bal,sort=random,limit=9] at @s run function rebal_piglins:inf_inv_bug/init